module     p0_ddbar_emnmumupnebar_d18h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p0
   ! _ddbar_emnmumupnebar/helicity1/d18h1l1.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emnmumupnebar_config, only: ki
   use p0_ddbar_emnmumupnebar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_ddbar_emnmumupnebar_groups, only: &
!           & sign => diagram18_sign, shift => diagram18_shift
      use p0_ddbar_emnmumupnebar_globalsl1, only: epspow
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_abbrevh1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d18
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d18 = 0.0_ki
      t1 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))
      d18 = (t1*abb18n7+abb18n5*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb18n&
      &6*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb18n6*(Q(1)*k5(1)-Q(2)*&
      &k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb18n9*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q&
      &(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*abb18n10*(Q(1)*spvak2k6(1)-Q(2)*spva&
      &k2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t1*abb18n11*(Q(1)*spvak3k1(1)-&
      &Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*abb18n2*(Q(1)*spva&
      &k2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t1*abb18n3*(Q&
      &(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t1*abb18n4*(Q(1)*k3(1)-Q(2)*k&
      &3(2)-Q(3)*k3(3)-Q(4)*k3(4))+t1*abb18n4*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-&
      &Q(4)*k6(4))+t1*abb18n8*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3&
      &)-Q(4)*spvak3k6(4)))
      numerator = cmplx(real(d18, ki), aimag(d18), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_ddbar_emnmumupnebar_globalsl1, only: epspow
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_abbrevh1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d18
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d18 = 0.0_ki
      t1 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))
      d18 = (t1*abb18n7+abb18n5*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb18n&
      &6*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb18n6*(Q(1)*k5(1)-Q(2)*&
      &k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb18n9*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q&
      &(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*abb18n10*(Q(1)*spvak2k6(1)-Q(2)*spva&
      &k2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t1*abb18n11*(Q(1)*spvak3k1(1)-&
      &Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*abb18n2*(Q(1)*spva&
      &k2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t1*abb18n3*(Q&
      &(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t1*abb18n4*(Q(1)*k3(1)-Q(2)*k&
      &3(2)-Q(3)*k3(3)-Q(4)*k3(4))+t1*abb18n4*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-&
      &Q(4)*k6(4))+t1*abb18n8*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3&
      &)-Q(4)*spvak3k6(4)))

      numerator = cmplx(real(d18, ki), aimag(d18), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_ddbar_emnmumupnebar_d18h1l1
