module     p0_ddbar_emnmumupnebar_d18h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p0
   ! _ddbar_emnmumupnebar/helicity1/d18h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emnmumupnebar_config, only: ki
   use p0_ddbar_emnmumupnebar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d18
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_emnmumupnebar_globalsl1, only: epspow
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_abbrevh1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = spvak4k5(iv1)
      if(deg.eq.1) then
         numerator = (k4(iv1)*abb18n18+k5(iv1)*abb18n18+spvak2k5(iv1)*abb18n16+t&
         &1*abb18n13)
         return
      end if
      t2 = spvak4k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb18n19+k1(iv1)*t2*abb18n21+k1(iv2)*t&
         &1*abb18n21+k3(iv1)*t2*abb18n20+k3(iv2)*t1*abb18n20+k6(iv1)*t2*abb18n20&
         &+k6(iv2)*t1*abb18n20+spvak2k1(iv1)*t2*abb18n22+spvak2k1(iv2)*t1*abb18n&
         &22+spvak2k6(iv1)*t2*abb18n15+spvak2k6(iv2)*t1*abb18n15+spvak3k1(iv1)*t&
         &2*abb18n14+spvak3k1(iv2)*t1*abb18n14+spvak3k6(iv1)*t2*abb18n17+spvak3k&
         &6(iv2)*t1*abb18n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d18:
   subroutine     reconstruct_d18(coeffs)
      use p0_ddbar_emnmumupnebar_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_18:
      coeffs%coeffs_18%c0 = derivative(czip)
      coeffs%coeffs_18%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_18%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_18%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_18%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_18%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_18%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_18%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_18%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_18%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_18%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_18%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_18%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_18%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_18%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_18:
   end subroutine reconstruct_d18
!---#] subroutine reconstruct_d18:
end module p0_ddbar_emnmumupnebar_d18h1l1d
