module     p1_uubar_emnmumupnebar_d15h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p1
   ! _uubar_emnmumupnebar/helicity1/d15h1l1.f90
   ! generator: haggies (1.1)
   use p1_uubar_emnmumupnebar_config, only: ki
   use p1_uubar_emnmumupnebar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p1_uubar_emnmumupnebar_groups, only: &
!           & sign => diagram15_sign, shift => diagram15_shift
      use p1_uubar_emnmumupnebar_globalsl1, only: epspow
      use p1_uubar_emnmumupnebar_kinematics
      use p1_uubar_emnmumupnebar_abbrevh1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d15
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d15 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t7 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t8 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d15 = (abb15n1+t1*abb15n14+t2*abb15n16+t3*abb15n17+t4*abb15n18+t5*abb15n2+&
      &t6*abb15n2+t7*abb15n3+t8*abb15n4+t9*abb15n5+t1*t10*abb15n9+t1*t2*abb15n21&
      &+t1*t4*abb15n26+t1*t7*abb15n7+t10*t5*abb15n8+t10*t6*abb15n8+t10*t7*abb15n&
      &12+t10*t8*abb15n15+t10*t9*abb15n11+t2*t5*abb15n22+t2*t6*abb15n22+t2*t7*ab&
      &b15n29+t2*t9*abb15n20+t3*t7*abb15n23+t3*t8*abb15n19+t4*t5*abb15n25+t4*t6*&
      &abb15n25+t4*t7*abb15n24+t4*t9*abb15n28+t7*t9*abb15n6+t7*abb15n10*(Q(1)*sp&
      &vak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))+t7*abb15n27&
      &*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+t8&
      &*t9*abb15n13+t3*t7*t8*abb15n30)
      numerator = cmplx(real(d15, ki), aimag(d15), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p1_uubar_emnmumupnebar_globalsl1, only: epspow
      use p1_uubar_emnmumupnebar_kinematics
      use p1_uubar_emnmumupnebar_abbrevh1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d15
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d15 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t7 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t8 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d15 = (abb15n1+t1*abb15n14+t2*abb15n16+t3*abb15n17+t4*abb15n18+t5*abb15n2+&
      &t6*abb15n2+t7*abb15n3+t8*abb15n4+t9*abb15n5+t1*t10*abb15n9+t1*t2*abb15n21&
      &+t1*t4*abb15n26+t1*t7*abb15n7+t10*t5*abb15n8+t10*t6*abb15n8+t10*t7*abb15n&
      &12+t10*t8*abb15n15+t10*t9*abb15n11+t2*t5*abb15n22+t2*t6*abb15n22+t2*t7*ab&
      &b15n29+t2*t9*abb15n20+t3*t7*abb15n23+t3*t8*abb15n19+t4*t5*abb15n25+t4*t6*&
      &abb15n25+t4*t7*abb15n24+t4*t9*abb15n28+t7*t9*abb15n6+t7*abb15n10*(Q(1)*sp&
      &vak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))+t7*abb15n27&
      &*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+t8&
      &*t9*abb15n13+t3*t7*t8*abb15n30)

      numerator = cmplx(real(d15, ki), aimag(d15), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p1_uubar_emnmumupnebar_d15h1l1
