module     p1_uubar_emnmumupnebar_d50h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p1
   ! _uubar_emnmumupnebar/helicity1/d50h1l1.f90
   ! generator: haggies (1.1)
   use p1_uubar_emnmumupnebar_config, only: ki
   use p1_uubar_emnmumupnebar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p1_uubar_emnmumupnebar_groups, only: &
!           & sign => diagram50_sign, shift => diagram50_shift
      use p1_uubar_emnmumupnebar_globalsl1, only: epspow
      use p1_uubar_emnmumupnebar_kinematics
      use p1_uubar_emnmumupnebar_abbrevh1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d50

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k3+k6
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d50 = 0.0_ki
      d50 = (abb50n1+abb50n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb50n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3&
      &k1(3)-Q(4)*spvak3k1(4))+abb50n4*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*s&
      &pvak2k5(3)-Q(4)*spvak2k5(4))+abb50n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(&
      &4)*k1(4))+abb50n6*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb50n6*(&
      &Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb50n7*(Q(1)*spvak4k5(1)-Q(&
      &2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+abb50n8*(Q(1)*spvak3k5(&
      &1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+abb50n9*(Q(1)*spva&
      &k4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)))
      numerator = cmplx(real(d50, ki), aimag(d50), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p1_uubar_emnmumupnebar_globalsl1, only: epspow
      use p1_uubar_emnmumupnebar_kinematics
      use p1_uubar_emnmumupnebar_abbrevh1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d50

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k3+k6
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d50 = 0.0_ki
      d50 = (abb50n1+abb50n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb50n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3&
      &k1(3)-Q(4)*spvak3k1(4))+abb50n4*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*s&
      &pvak2k5(3)-Q(4)*spvak2k5(4))+abb50n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(&
      &4)*k1(4))+abb50n6*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb50n6*(&
      &Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb50n7*(Q(1)*spvak4k5(1)-Q(&
      &2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+abb50n8*(Q(1)*spvak3k5(&
      &1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+abb50n9*(Q(1)*spva&
      &k4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)))

      numerator = cmplx(real(d50, ki), aimag(d50), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p1_uubar_emnmumupnebar_d50h1l1
